program matrica;

const N = 100;

type matrix = record
	m:array [1..N, 1..N] of integer; { pati matrica (y,x) }
	x,y:integer; { matricos dydis }
end;

procedure matrix_nuskaityti(var mat:matrix);
	var i,j:integer;
begin
	writeln('Iveskite stulpeliu skaiciu:'); { skaitymas is STDOUT }
	read(mat.x); { skaitymas is STDIN }
	writeln('Iveskite eiluciu skaiciu:');
	read(mat.y);

	writeln('Iveskite elementus');
	for i := 1 to mat.y do
		for j := 1 to mat.x do 
			read(mat.m[i, j]);

	readln;
end;

procedure matrix_atspauzdinti(var mat:matrix);
	var i,j:integer;
begin
	for i := 1 to mat.y do begin
		for j := 1 to mat.x do begin
			write(mat.m[i, j]:3, ',');
		end;
		writeln;
	end;
end;

procedure matrix_pertvarkyti(var dest, source:matrix);
	var i,j,k:integer;
begin
	dest.y := 4;
	dest.x := 0;
	k := -1;

	for j := 1 to source.x do begin
		for i := 1 to source.y do begin
			{ randame elementa }
			if source.m[i, j] <> 0 then begin
				inc(dest.x);
				dest.m[1, dest.x] := i;
				dest.m[2, dest.x] := j;
				dest.m[3, dest.x] := source.m[i, j];
				dest.m[4, dest.x] := 0; { jeigu veliau rasime elementa, cia idesime }

				{
					jei praeitas elementas buvo sitame stulpelyje,
					reikia, kad jo 4 stulpelio elementas rodytu i sita
				}

				if (k = j) then
					dest.m[4, dest.x-1] := dest.x;

				k := j;
			end;
		end;
	end;
end;

procedure matrix_spauzdinti_salia(var prad, pert:matrix);
begin

	writeln('Ivesta');
	matrix_atspauzdinti(prad);
	writeln('Pertvarkyta');
	matrix_atspauzdinti(pert);
end;

procedure matrix_sudeti(var dest, a, b:matrix);
var i, j:integer;
begin
	if (a.x <> b.x) or (a.y <> b.y) then begin
		writeln('Matricu dydziai nesutampa');
		exit;
	end;

	dest.x := a.x;
	dest.y := a.y;

	for i := 1 to dest.y do
		for j := 1 to dest.x do
			dest.m[i, j] := a.m[i, j] + b.m[i, j];
end;

var p1, p2, m1, m2, m3:matrix;
begin
	matrix_nuskaityti(m1);
	matrix_pertvarkyti(p1, m1);
	matrix_spauzdinti_salia(m1, p1);

	matrix_nuskaityti(m2);
	matrix_pertvarkyti(p2, m2);
	matrix_spauzdinti_salia(m2, p2);

	matrix_sudeti(m3, p1, p2);
	writeln('Pertvarkytu suma');
	matrix_atspauzdinti(m3);
end.
